﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using OpenTK;
//using OpenTK.Graphics;
using OpenTK.Graphics.OpenGL;
using OpenTK.Audio;
using OpenTK.Audio.OpenAL;
using OpenTK.Input;
using GLTools;


namespace WindowsFormsApplication2
{

    public partial class Form1 : Form
    {
        float AngleX = 0;
        float AngleY = 0;
        float AngleZ = 0;
        
        const float AngleDl = 5;

       Bitmap bmpTex;

        public Form1()
        {
            InitializeComponent();
            
        }

        private void glControl1_Resize(object sender, EventArgs e)
        {
            SetupViewport();
            glControl1.Invalidate();
        }

        private void SetupViewport()
        {
            int w = glControl1.Width;
            int h = glControl1.Height;

            GL.MatrixMode(MatrixMode.Projection);
            GL.LoadIdentity();
            GL.Ortho(-1, 1, -1, 1, -1, 1);
            GL.MatrixMode(MatrixMode.Modelview);

            GL.Viewport(0, 0, w, h); 

        }


        void sphere(double r, int nx, int ny)
        {
            double x, y, z;
        
          for (int iy=0; iy < ny; ++iy)
            {
              GL.Begin(BeginMode.QuadStrip);
              for (int ix = 0; ix <= nx; ++ix)
              {
                  x = r * Math.Sin(iy * Math.PI / ny) * Math.Cos(2 * ix * Math.PI / nx);
                  y = r * Math.Sin(iy * Math.PI / ny) * Math.Sin(2 * ix * Math.PI / nx);
                  z = r * Math.Cos(iy * Math.PI / ny);
                  GL.Normal3(x, y, z);//нормаль направлена от центра
                  GL.TexCoord2((double)ix / (double)nx, (double)iy / (double)ny);
                  GL.Vertex3(x, y, z);

                  x = r * Math.Sin((iy + 1) * Math.PI / ny) * Math.Cos(2 * ix * Math.PI / nx);
                  y = r * Math.Sin((iy + 1) * Math.PI / ny) * Math.Sin(2 * ix * Math.PI / nx);
                  z = r * Math.Cos((iy + 1) * Math.PI / ny);
                  GL.Normal3(x, y, z);
                  GL.TexCoord2((double)ix / (double)nx, (double)(iy + 1) / (double)ny);
                  GL.Vertex3(x, y, z);
              }
              GL.End();
            }
        }


        void DrawObjects()
        {
            // формирование изображения
            GL.Enable(EnableCap.Lighting);
            GL.Enable(EnableCap.Light0);
            sphere(0.5, 20, 20);
            GL.Disable(EnableCap.Lighting);
            // завершение формирования изображения
        }

        void DrawScene(Jitter.PointPloat[] j)
        {
            GL.Clear(ClearBufferMask.AccumBufferBit);
            for (int i = 0; i< j.Length-1; ++i)
            {
                GL.Clear(ClearBufferMask.ColorBufferBit | ClearBufferMask.DepthBufferBit);
                Jitter.AccOrtho(-1, 1, -1, 1, -1, 1, j[i].X, j[i].Y);
                DrawObjects();
                GL.Accum(AccumOp.Accum, 1.0f/j.Length);
            }
            GL.Accum(AccumOp.Return, 1.0f);
       }


        private void glControl1_Paint(object sender, PaintEventArgs e)
        {

            // очистка буферов цвета и глубины
            GL.Clear(ClearBufferMask.ColorBufferBit | ClearBufferMask.DepthBufferBit);

            // поворот изображения
            GL.LoadIdentity();
            GL.Rotate(AngleX, 1.0, 0.0, 0.0);
            GL.Rotate(AngleY, 0.0, 1.0, 0.0);
            GL.Rotate(AngleZ, 0.0, 0.0, 1.0);


            DrawScene(Jitter.j8);


            GL.Flush();
            GL.Finish();

            glControl1.SwapBuffers();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            SetupViewport();
            GL.ClearColor(1f, 1f, 1f, 1f); // цвет фона
            GL.Enable(EnableCap.DepthTest);

            bmpTex = new Bitmap("OGL64x64.bmp");

            GLTexture.LoadTexture(bmpTex);

            GL.TexParameter(TextureTarget.Texture2D, TextureParameterName.TextureMinFilter, (int)TextureMinFilter.Linear);
            GL.TexParameter(TextureTarget.Texture2D, TextureParameterName.TextureMagFilter, (int)TextureMagFilter.Linear);

            GL.Enable(EnableCap.Texture2D);
            GL.Enable(EnableCap.Lighting);
            GL.Enable(EnableCap.Light0);
            

            AngleX = 30;
            AngleY = 30;

        }

        private void glControl1_KeyDown(object sender, KeyEventArgs e)
        {
            switch(e.KeyCode)
            {
                case Keys.Insert: 
                    AngleX += AngleDl;
                    break;
                case Keys.Delete: 
                    AngleX -= AngleDl;
                    break;
                case Keys.Home: 
                    AngleY += AngleDl;
                    break;
                case Keys.End: 
                    AngleY -= AngleDl;
                    break;
                case Keys.Prior: 
                    AngleZ += AngleDl;
                    break;
                case Keys.Next: 
                    AngleZ -= AngleDl;
                    break;
            }
            glControl1.Invalidate(); 
        }
    }
}
