unit Jitter;
interface
uses  OpenGL;
Type
  TGLPointFloat = record
    x,y: GLFloat;
  End;
const
  j2: array[0..1] of TGLPointFloat =  
    ((x:  0.246490; y:  0.249999), (x: -0.246490; y: -0.249999));
  j3: array[0..2] of TGLPointFloat = 
    ((x: -0.373411; y: -0.250550), (x:  0.256263; y:  0.368119),            
     (x:  0.117148; y: -0.117570));
  j4: array[0..3] of TGLPointFloat =
    ((x: -0.208147; y:  0.353730), (x:  0.203849; y: -0.353780),
     (x: -0.292626; y: -0.149945), (x:  0.296924; y:  0.149994));
  j8: array[0..7] of TGLPointFloat =
     ((x: -0.334818; y:  0.435331), (x:  0.286438; y: -0.393495),
      (x:  0.459462; y:  0.141540), (x: -0.414498; y: -0.192829),
      (x: -0.183790; y:  0.082102), (x: -0.079263; y: -0.317383),
      (x:  0.102254; y:  0.299133), (x:  0.164216; y: -0.054399));

procedure AccFrustum(left,right,bottom,top: GLdouble; anear,afar,pdx,pdy: GLdouble);
procedure AccOrtho(left, right, bottom, top: GLdouble; anear, afar, pdx, pdy: GLdouble);

Implementation
procedure AccFrustum(left, right, bottom, top: GLdouble; anear, afar, pdx, pdy: GLdouble);
var
  xwsize, ywsize: GLdouble;
  dx, dy: GLdouble;
  viewport: array[0..3] of GLint;
begin
  glGetIntegerv (GL_VIEWPORT, @viewport);
  xwsize := right - left;
  ywsize := top - bottom;
  dx := -(pdx*xwsize/viewport[2]);
  dy := -(pdy*ywsize/viewport[3]);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glFrustum (left + dx, right + dx, bottom + dy, top + dy, anear, afar);
  glMatrixMode(GL_MODELVIEW);
end;

procedure AccOrtho(left, right, bottom, top: GLdouble; anear, afar, pdx, pdy: GLdouble);
var
  xwsize, ywsize  : GLdouble;
  dx, dy: GLdouble;
  viewport: array[0..3] of GLint;
begin
  glGetIntegerv (GL_VIEWPORT, @viewport);
  xwsize := right - left;
  ywsize := top - bottom;
  dx := -(pdx*xwsize/viewport[2]);
  dy := -(pdy*ywsize/viewport[3]);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(left + dx, right + dx, bottom + dy, top + dy, anear, afar);
  glMatrixMode(GL_MODELVIEW);
end;

end.

